unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, JPEG, ImgList, StdCtrls, Clipbrd;

type
  TFormMK = class(TForm)
    FaceBox: TPaintBox;
    RefreshTimer: TTimer;
    IList: TImageList;
    CursorTimer: TTimer;
    KeyTimer: TTimer;
    EditTimer: TTimer;
    procedure RefreshTimerTimer(Sender: TObject);
    procedure FaceBoxMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FaceBoxMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FaceBoxMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure CursorTimerTimer(Sender: TObject);
    procedure KeyTimerTimer(Sender: TObject);
    procedure EditTimerTimer(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FormMK: TFormMK;

implementation

{$R *.dfm}

uses MemMK;

const CopyRight = '   ..';
      Path = 'Skins/';
      FontName = 'Asci.dat';
      FaceName = 'Face.jpg';
      CloakName = 'Cloak.bmp';
      OnName = 'On.bmp';
      OffName = 'Off.bmp';
      WhiteUpName = 'WhiteUp.bmp';
      WhiteDownName = 'WhiteDown.bmp';
      BlackUpName = 'BlackUp.bmp';
      BlackDownName = 'BlackDown.bmp';
      ExeUpName = 'ExeUp.bmp';
      ExeDownName = 'ExeDown.bmp';
      MK85Name = 'MK85.bmp';
      MName = 'M.bmp';

      KeyDl = 500; {   }
      KeyPs = 50; {  }

      OutDl = 1500; {   }
      OutPs = 220; { }

      MaxLen = 63; {   }
      WarPos = 57; {,    }

type TMKFont = array[0..191,0..6] of Byte;

var BitMap, Face, Cloak, MemFace: TBitMap;
    Fnt: TMKFont;
    MD: Boolean;
    XPos, YPos: Integer;
    State: Integer;
    Scr: array[0..59,0..6] of Boolean;
    Hlp: array[0..9] of Boolean;
    Num: string[4];
    BkColor: TColor;
    CurPos, CurDn, CurUp: Byte;
    CurMem: array[0..4,0..6] of Boolean;
    CurVis: Boolean;
    ViewMatrix: Boolean = False; { : , }

    BTest: Boolean;

    CtrlV: Boolean;

    StopKey: Boolean;
    KeyCode: Byte;
    SShift, FShift: Boolean;
    ANSLine: string;
    EditLine: string;
    EditPos: Integer;
    EditCls: Boolean;


procedure ErrorMes (Mes: string);
//   :
begin

  Beep;
end; {proc ErrorMes}

procedure Delay (Ms: LongInt);
// :
var Tim: LongInt;
begin
  Tim := GetTickCount;
  repeat
    Application.ProcessMessages;
  until GetTickCount - Tim > Ms;
end; {proc Delay}

procedure Stop;
//    Stop:
begin
  while StopKey do
    Application.ProcessMessages;
end; {proc Stop}

procedure SetCursor (Pos, Dn, Up: Byte);
//  :
var I, J: Integer;
begin
  CurPos := Pos;
  CurDn := Dn;
  CurUp := Up;
  for I := 0 to 4 do
    for J := 0 to 6 do
      CurMem[I,J] := Scr[I+Pos*5,J];
  CurVis := False;
  FormMK.CursorTimer.Enabled := True;
  FormMK.CursorTimerTimer (nil);  
end; {proc SetCursor}

procedure View;
//   :
var X, Y: Integer;
    SX, SY: Integer;
begin
  with Face.Canvas do
  begin
    for X := 0 to 59 do
      for Y := 0 to 6 do
      begin
        if Scr[X,Y] then Pen.Color := clBlack
                    else Pen.Color := BkColor;
        SX := 44 + X * 2 + (X div 5) * 4;
        if ViewMatrix then SY := 41 + Y * 4
                      else SY := 46 + Y * 3;
        MoveTo (SX, SY);
        if ViewMatrix then LineTo (SX, SY + 3)
                      else LineTo (SX, SY + 2);
      end; {for}
    Num := UpperCase (Num);
    for X := 1 to 4 do
    begin
      case Num[X] of
        '0'..'9': Y := Ord (Num[X]) - 48;
        'A'..'F': Y := Ord (Num[X]) - 46;
        '-': Y := 16;
        'P': Y := 17;
        else Y := -1;
      end; {case}
      SX := 159 + (X - 1) * 7;
      SY := 26;
      if Y = -1 then
      begin
        Brush.Color := clWhite;
        Pen.Color := clWhite;
        Rectangle (SX, SY, SX + 5, SY + 11);
      end else FormMK.IList.Draw (Face.Canvas, SX, SY, Y);
    end; {for}
    for X := 0 to 9 do
    begin
      if Hlp[X] then
      begin
        BitMap.Transparent := False;
        case X of
          0: if FileExists (Concat (Path, 'EXT.bmp')) then
             begin
               BitMap.LoadFromFile (Concat (Path, 'EXT.bmp'));
               Draw (41, 29, BitMap);
             end; {if}
          1: if FileExists (Concat (Path, 'S.bmp')) then
             begin
               BitMap.LoadFromFile (Concat (Path, 'S.bmp'));
               Draw (60, 26, BitMap);
             end; {if}
          2: if FileExists (Concat (Path, 'F.bmp')) then
             begin
               BitMap.LoadFromFile (Concat (Path, 'F.bmp'));
               Draw (60, 32, BitMap);
             end; {if}
          3: if FileExists (Concat (Path, 'RUN.bmp')) then
             begin
               BitMap.LoadFromFile (Concat (Path, 'RUN.bmp'));
               Draw (69, 26, BitMap);
             end; {if}
          4: if FileExists (Concat (Path, 'WRT.bmp')) then
             begin
               BitMap.LoadFromFile (Concat (Path, 'WRT.bmp'));
               Draw (69, 32, BitMap);
             end; {if}
          5: if FileExists (Concat (Path, 'DEG.bmp')) then
             begin
               BitMap.LoadFromFile (Concat (Path, 'DEG.bmp'));
               Draw (89, 29, BitMap);
             end; {if}
          6: if FileExists (Concat (Path, 'RAD.bmp')) then
             begin
               BitMap.LoadFromFile (Concat (Path, 'RAD.bmp'));
               Draw (106, 29, BitMap);
             end; {if}
          7: if FileExists (Concat (Path, 'GRA.bmp')) then
             begin
               BitMap.LoadFromFile (Concat (Path, 'GRA.bmp'));
               Draw (125, 29, BitMap);
             end; {if}
          8: if FileExists (Concat (Path, 'TR.bmp')) then
             begin
               BitMap.LoadFromFile (Concat (Path, 'TR.bmp'));
               Draw (144, 29, BitMap);
             end; {if}
          9: if FileExists (Concat (Path, 'STOP.bmp')) then
             begin
               BitMap.LoadFromFile (Concat (Path, 'STOP.bmp'));
               Draw (189, 29, BitMap);
             end; {if}
        end; {case}
      end else
      begin
        Pen.Color := clWhite;
        Brush.Color := clWhite;
        case X of
          0: Rectangle (41, 29, 56, 34);
          1: Rectangle (60, 26, 65, 31);
          2: Rectangle (60, 32, 65, 37);
          3: Rectangle (69, 26, 85, 31);
          4: Rectangle (69, 32, 85, 37);
          5: Rectangle (89, 29, 102, 34);
          6: Rectangle (106, 29, 121, 34);
          7: Rectangle (125, 29, 140, 34);
          8: Rectangle (144, 29, 154, 34);
          9: Rectangle (189, 29, 210, 34);
        end; {case}
      end; {if}
    end; {for}
  end; {with}
end; {proc View}

procedure HideCursor;
//  :
var I, J: Integer;
begin
  if FormMK.CursorTimer.Enabled then
  begin
    FormMK.CursorTimer.Enabled := False;
    for I := 0 to 4 do
      for J := 0 to 6 do
        Scr[CurPos*5+I,J] := CurMem[I,J];
    View;
    CurVis := False;
  end; {if}
end; {proc HideCursor}

procedure OpenFont;
//  :
var F: file of Byte;
    I, J: Byte;
begin
  {$I-}
  AssignFile (F, Concat (Path, FontName));
  Reset (F);
  for I := 0 to 191 do
    for J := 0 to 6 do
      Read (F, Fnt[I,J]);
  CloseFile (F);
  {$I+}
  if IOResult <> 0 then ErrorMes (FontName);
end; {proc OpenFont}

procedure SetChar (Pos, C: Byte);
//  :
var X, Y: Integer;
    Tmp: Byte;
begin
  for Y := 0 to 6 do
  begin
    Tmp := Fnt[C,Y];
    for X := 0 to 4 do
    begin
      Scr[X+Pos*5,Y] := Odd (Tmp);
      Tmp := Tmp shr 1;
    end; {for}
  end; {for}
  View;
end; {proc SetChar}

procedure SetText (Pos: Byte; Txt: string);
//  :
var I: Integer;
begin
  for I := 1 to Length (Txt) do
  begin
    SetChar (Pos, Ord (Txt[I]));
    Inc (Pos);
  end; {for}
end; {proc SetText}

procedure Scroll;
//      :
var I, J: Integer;
begin
  for I := 5 to 59 do
    for J := 0 to 6 do
      Scr[I-5,J] := Scr[I,J];
  View;
end; {proc Scroll}

procedure OutText (Pos: Byte; Txt: string; CR: Boolean);
//     :
var I: Integer;
begin
  HideCursor;
  I := 1;
  while (Pos < 12) and (I <= Length (Txt)) do
  begin
    SetChar (Pos, Ord (Txt[I]));
    Inc (Pos);
    Inc (I);
  end; {while}
  if I <= Length (Txt) then
  begin
    Delay (OutDl);
    Stop;
    while I <= Length (Txt) do
    begin
      Scroll;
      SetChar (11, Ord (Txt[I]));
      Delay (OutPs);
      Stop;
      Inc (I);
    end; {while}
  end; {if}
  EditCls := CR;
  EditPos := 1;
end; {proc OutText}

procedure Cls;
//  :
var I, J: Integer;
begin
  for I := 0 to 59 do
    for J := 0 to 6 do
      Scr[I,J] := False;
  EditPos := 1;
  EditLine := '';
  View;
end; {proc Cls}

function DeCoder (Txt: string; ToMK: Boolean): string;
//   :
const PC = '_{}߸';
      MK: array[1..69] of Byte =
      (15,7,8,
       129,130,151,135,132,133,150,154,137,138,139,140,141,142,143,144,146,147,148,149,134,136,131,158,155,157,31,153,152,156,128,145,
       161,162,183,167,164,165,182,186,169,170,171,172,173,174,175,176,178,179,180,181,166,168,163,190,187,189,30,185,184,188,160,177,
       159,191);
var I, J: Integer;
begin
  for I := 1 to Length (Txt) do
  begin
    if ToMK then
    begin
      for J := 1 to Length (PC) do
        if Txt[I] = PC[J] then
        begin
          Txt[I] := Chr (MK[J]);
          Break;
        end; {if}
    end else
    begin
      for J := 1 to 69 do
        if Txt[I] = Chr (MK[J]) then
        begin
          Txt[I] := PC[J];
          Break;
        end; {if}
    end; {if}
  end; {for}
  Result := Txt;
end; {proc DeCoder}

procedure Init;
//    :
var Ok: Boolean;
    JPGFace: TPicture;
    X, Y: Integer;
begin
  HideCursor;
  JPGFace := TPicture.Create;
  Ok := False;
  if FileExists (Concat (Path, FaceName)) Then
  begin
    JPGFace.LoadFromFile (Concat (Path, FaceName));
    Ok := JPGFace.Graphic is TJPEGImage;
    if Ok then
    with TJPEGImage (JPGFace.Graphic) do
    begin
      PixelFormat := jf24Bit;
      Scale := jsFullSize;
      GrayScale := False;
      Performance := jpBestQuality;
      ProgressiveDisplay := False;
      Face.Width := JPGFace.Width;
      Face.Height := JPGFace.Height;
      Face.Canvas.Draw (0, 0, JPGFace.Graphic);
    end; {with}
  end; {if}
  JPGFace.Free;
  with Face do
  begin
    if not Ok then
    begin
      Width := 572;
      Height := 248;
      Canvas.Brush.Color := clSilver;
      Canvas.Pen.Color := clBlack;
      Canvas.Rectangle (0, 0, Width, Height);
      ErrorMes (FaceName);
    end; {if}
    if FileExists (Concat (Path, OnName)) Then
    begin
      BitMap.LoadFromFile (Concat (Path, OnName));
      Canvas.Draw (56, 106, BitMap);
    end else ErrorMes (OnName);
    BitMap.Transparent := True;
    if FileExists (Concat (Path, WhiteUpName)) Then
    begin
      BitMap.LoadFromFile (Concat (Path, WhiteUpName));
      BitMap.TransparentColor := BitMap.Canvas.Pixels [BitMap.Width div 2, BitMap.Height div 2];
      for Y := 0 to 3 do
      begin
        for X := 0 to 9 do
        begin
          if (X > 4) or (Y > 0)
             then Canvas.Draw (18 + 38 * X, 107 + 33 * Y, BitMap);
        end; {for}
      end; {for}
    end else ErrorMes (WhiteUpName);
    if FileExists (Concat (Path, BlackUpName)) Then
    begin
      BitMap.LoadFromFile (Concat (Path, BlackUpName));
      BitMap.TransparentColor := BitMap.Canvas.Pixels [BitMap.Width div 2, BitMap.Height div 2];
      for Y := 0 to 4 do
      begin
        for X := 0 to 3 do
        begin
          if (X < 2) or (Y < 4)
             then Canvas.Draw (411 + 37 * X, 55 + 37 * Y, BitMap);
        end; {for}
      end; {for}
    end else ErrorMes (BlackUpName);;
    if FileExists (Concat (Path, ExeUpName)) Then
    begin
      BitMap.LoadFromFile (Concat (Path, ExeUpName));
      BitMap.TransparentColor := BitMap.Canvas.Pixels [BitMap.Width div 2, BitMap.Height div 2];
      Canvas.Draw (485, 203, BitMap);
    end else ErrorMes (ExeUpName);
    if (MemTotal = 1221) or (MemTotal = 5317) then
    begin
      BitMap.Transparent := False;
      if FileExists (Concat (Path, MK85Name)) Then
      begin
        BitMap.LoadFromFile (Concat (Path, MK85Name));
        if MemTotal = 5317 then
        begin
          Canvas.Draw (477, 27, BitMap);
          if FileExists (Concat (Path, MName)) Then
          begin
            BitMap.LoadFromFile (Concat (Path, MName));
            Canvas.Draw (543, 27, BitMap);
          end else ErrorMes (MName);
        end else Canvas.Draw (496, 27, BitMap);
      end else ErrorMes (MK85Name);
    end; {if}
  end; {with}
  if FileExists (Concat (Path, CloakName)) Then
  begin
    Cloak.LoadFromFile (Concat (Path, CloakName));
    Cloak.TransparentColor := clYellow;
    Cloak.Transparent := True;
  end else ErrorMes (CloakName);
  MemFace.Width := Cloak.Width;
  MemFace.Height := Cloak.Height;
  MemFace.Canvas.Draw (-14, -131, Face);
  for X := 0 to 59 do
    for Y := 0 to 6 do
      Scr[X,Y] := False;
  for X := 0 to 9 do
    Hlp[X] := False;
  Num := '    ';
  View;
  ANSLine := '0';
  with FormMK do
  begin
    EditTimer.Enabled := False;
    KeyTimer.Enabled := False;
    HideCursor;
  end; {with}
  if MemTotal < 8 then
  begin
    BTest := True;
    SetText (0, DeCoder (' ', True));
  end else MemCreate;
end; {proc Init}

procedure SetOne;
//   :
begin

  with FormMK do
  begin
    FormCreate (nil);
    FormShow (nil);
  end; {with}
end; {proc SetOne}

procedure Test;
//  :
const Ps = 1600;
var I, J: Integer;
begin
  BTest := True;
  Init;
  Cls;
  Delay (Ps * 2);
  Stop;
  for I := 0 to 9 do
  begin
    Hlp[I] := True;
    View;
    Delay (Ps);
    Stop;
    Hlp[I] := False;
  end; {for}
  for I := 1 to 9 do
  begin
    Num := Concat (Chr (48 + I), Chr (48 + I), Chr (48 + I), Chr (48 + I));
    View;
    Delay (Ps);
    Stop;
  end; {for}
  for I := 0 to 9 do
    Hlp[I] := True;
  Num := '8888';
  View;
  Delay (Ps);
  Stop;
  for I := 0 to 9 do
    Hlp[I] := False;
  Num := '    ';
  for J := 0 to 6 do
  begin
    for I := 0 to 59 do
      Scr[I,J] := True;
    View;
    Delay (Ps);
    Stop;
    for I := 0 to 59 do
      Scr[I,J] := False;
  end; {for}
  for I := 0 to 59 do
  begin
    for J := 0 to 6 do
      Scr[I,J] := True;
    View;
    Delay (Ps div 4);
    Stop;
    for J := 0 to 6 do
      Scr[I,J] := False;
  end; {for}
  BTest := False;
  SetOne;
end; {proc Test}

procedure InKey (Key: Integer; Down: Boolean);
//   :
const Liter = 'QWERTYUIOPASDFGHJKLaZXCVBNM ={cds/789*456-123+0.x';
      SLiter = '!"#$()?:;,ASDFGHJKLaZXCVBNM \|cds<789>456_123~0^x';
      MLiter = 'qwertyuiopasdfghjklAzxcvbnmCDS7894561230.X';
      eLiter = 'A =ECDS/789*456-123+0.X';
      MeLiter = 'acds7894561230.x';
      SeLiter: array[1..49] of Byte =
        (37,39,64,27,91,93,38,25,24,26,11,28,14,16,17,18,19,20,21,9,127,29,13,15,12,23,22,32,92,124,
         7,8,0,60,55,56,57,62,52,53,54,95,49,50,51,126,48,94,4);
var C: Char;
    MD: Boolean;
begin
  StopKey := (Key = 42);
  if (not BTest) and (Key > 4) then
  begin
    MD := False;
    if Key = 5 then
    begin {MODE}
      if Hlp[1] and Hlp[2] or not Down then
      begin
        Hlp[1] := False;
        Hlp[2] := False;
      end else
      begin
        Hlp[1] := True;
        Hlp[2] := True;
      end; {if}
    end; {if}
    if Key = 8 then
    begin {S}
      if Hlp[1] and not Hlp[2] or not Down then
      begin
        Hlp[1] := False;
      end else
      begin
        Hlp[1] := True;
        Hlp[2] := False;
      end; {if}
    end; {if}
    if Key = 9 then
    begin {S}
      if not Hlp[1] and Hlp[2] or not Down then
      begin
        Hlp[2] := False;
      end else
      begin
        Hlp[1] := False;
        Hlp[2] := True;
      end; {if}
    end; {if}
    if Down then
    begin
      SShift := Hlp[1];
      FShift := Hlp[2];
    end; {if}
    if SShift and FShift and (Key = 57) then
    begin {MODE+.}
      Hlp[0] := not Hlp[0];
      MD := True;
      with Face.Canvas do
        if Hlp[0] then Draw (14, 131, Cloak)
                  else Draw (14, 131, MemFace);
    end; {if}
    if MD then
    begin
      Hlp[1] := False;
      Hlp[2] := False;
    end; {if}
    if (Key in [5,8,9]) or MD then
    begin
      View;
      KeyCode := 0;
      Exit;
    end; {if}
    if not Hlp[0] then
    begin { EXT}
      if not SShift then
      begin { :}
        C := Liter[Key-9];
        case C of
          'a': KeyCode := 9;
          's': KeyCode := 0;
          else KeyCode := Ord (C);
        end; {case}
      end; {if}
      if SShift and not FShift then
      begin {SShift:}
        C := SLiter[Key-9];
        case C of
          'a': KeyCode := 9;
          's': KeyCode := 0;
          else KeyCode := Ord (C);
        end; {case}
      end; {if}
      if SShift and FShift then
      begin {MODE:}
        C := DeCoder (MLiter[Key-9], True)[1];
        case C of
          'A': KeyCode := 9;
          'S': KeyCode := 0;
          else KeyCode := Ord (C);
        end; {case}
      end; {if}
    end else
    begin {EXT}
      if not SShift and not FShift then
      begin { :}
        C := DeCoder (eLiter[Key-9], True)[1];
        case C of
          'A': KeyCode := 9;
          'E': KeyCode := 123;
          'S': KeyCode := 0;
          else KeyCode := Ord (C);
        end; {case}
      end; {if}
      if not SShift and FShift then
      begin {FShift:}
        C := Liter[Key-9];
        case C of
          'a': KeyCode := 9;
          's': KeyCode := 0;
          else KeyCode := Ord (C);
        end; {case}
      end; {if}
      if SShift and not FShift then
      begin {SShift:}
        KeyCode := SeLiter[Key-9];
      end; {if}
      if SShift and FShift then
      begin {MODE:}
        C := DeCoder (MeLiter[Key-9], True)[1];
        case C of
          'a': KeyCode := 9;
          's': KeyCode := 0;
          else KeyCode := Ord (C);
        end; {case}
      end; {if}

    end; {if}

    case Key of
      6: KeyCode := 5;
      7: KeyCode := 6;
      40: KeyCode := 7;
      41: KeyCode := 8;
      58: KeyCode := 4;
    end; {case}
    Hlp[1] := False;
    Hlp[2] := False;
    View;
  end; {if}
end; {proc InKey}

procedure ShowEdit;
//   :
var I: Integer;
begin
  if EditPos < 12 then
  begin
    for I := 1 to 12 do
      if I <= Length (EditLine)
        then SetChar (I - 1, Ord (EditLine[I]))
        else SetChar (I - 1, 32);
    if Length (EditLine) < WarPos
      then SetCursor (EditPos - 1, 6, 6)
      else SetCursor (EditPos - 1, 0, 6);
  end else
  begin
    for I := 0 to 11 do
      SetChar (I, Ord (EditLine[EditPos-11+I]));
    if Length (EditLine) < WarPos
      then SetCursor (11, 6, 6)
      else SetCursor (11, 0, 6);
  end; {if}
end; {proc ShowEdit}

procedure EXE;
//    :
begin

  if Pos ('TEST', Trim (EditLine)) = 1 then Test;
  if Pos ('WHO', Trim (EditLine)) = 1 then OutText (0, DeCoder (CopyRight, True), True);
  EditLine := '';
end; {proc EXE}


procedure TFormMK.RefreshTimerTimer(Sender: TObject);
begin
  FaceBox.Canvas.Draw (0, 0, Face);
end;

procedure TFormMK.FaceBoxMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var DKey: Boolean;
    I, J, L, T: Integer;
begin
  if Button <> mbLeft then Exit;
  DKey := False;
  if (X >= 56) and (X <= 86) and (Y >= 106) and (Y <= 126) then
  begin {Power}
    if FileExists (Concat (Path, OffName)) Then
    begin
      BitMap.LoadFromFile (Concat (Path, OffName));
      Face.Canvas.Draw (56, 106, BitMap);
    end; {if}
    State := 1;
    DKey := True;
  end; {if}
  if (X >= 485) and (X <= 548) and (Y >= 203) and (Y <= 223) then
  begin {EXE}
    if FileExists (Concat (Path, ExeDownName)) Then
    begin
      BitMap.LoadFromFile (Concat (Path, ExeDownName));
      BitMap.Transparent := True;
      BitMap.TransparentColor := BitMap.Canvas.Pixels [BitMap.Width div 2, BitMap.Height div 2];
      Face.Canvas.Draw (485, 203, BitMap);
    end; {if}
    State := 58;
    DKey := True;
  end; {if}
  for J := 0 to 3 do
  begin
    for I := 0 to 9 do
    begin
      L := 18 + 38 * I;
      T := 107 + 33 * J;
      if ((I > 4) or (J > 0)) and
         (X >= L) and (X <= L + 30) and (Y >= T) and (Y <= T + 18)
         then
         begin
           DKey := True;
           State := 10 * J + I;
           if FileExists (Concat (Path, WhiteDownName)) Then
           begin
             BitMap.LoadFromFile (Concat (Path, WhiteDownName));
             BitMap.Transparent := True;
             BitMap.TransparentColor := BitMap.Canvas.Pixels [BitMap.Width div 2, BitMap.Height div 2];
             Face.Canvas.Draw (18 + 38 * (State mod 10), 107 + 33 * (State div 10), BitMap);
           end; {if}
         end; {if}
    end; {for}
  end; {for}
  for J := 0 to 4 do
  begin
    for I := 0 to 3 do
    begin
      L := 411 + 37 * I;
      T := 55 + 37 * J;
      if ((I < 2) or (J < 4)) and
         (X >= L) and (X <= L + 26) and (Y >= T) and (Y <= T + 20)
         then
         begin
           DKey := True;
           State := 4 * J + I + 40;
           if FileExists (Concat (Path, BlackDownName)) Then
           begin
             BitMap.LoadFromFile (Concat (Path, BlackDownName));
             BitMap.Transparent := True;
             BitMap.TransparentColor := BitMap.Canvas.Pixels [BitMap.Width div 2, BitMap.Height div 2];
             Face.Canvas.Draw (411 + 37 * ((State - 40) mod 4), 55 + 37 * ((State - 40) div 4), BitMap);
           end; {if}
         end; {if}
    end; {for}
  end; {for}

  if not DKey then
  begin
    MD := True;
    XPos := X;
    YPos := Y;
    State := 0;
  end else
  begin
    InKey (State, True);
    KeyTimer.Interval := KeyDl;
    KeyTimer.Enabled := True;
  end; {if}
end;

procedure TFormMK.FaceBoxMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var L, T: Integer;
begin
  if Button <> mbLeft then Exit;
  MD := False;
  case State of
    1: if (X >= 56) and (X <= 86) and (Y >= 106) and (Y <= 126) then Close;
    5..39: begin {White Key}
             L := 18 + 38 * (State mod 10);
             T := 107 + 33 * (State div 10);
             BitMap.Transparent := True;
             if FileExists (Concat (Path, WhiteUpName)) Then
             begin
               BitMap.LoadFromFile (Concat (Path, WhiteUpName));
               BitMap.TransparentColor := BitMap.Canvas.Pixels [BitMap.Width div 2, BitMap.Height div 2];
               Face.Canvas.Draw (18 + 38 * (State mod 10), 107 + 33 * (State div 10), BitMap);
             end; {if}
           end; {5..39}
    40..57: begin {Black Key}
              L := 411 + 37 * ((State - 40) mod 4);
              T := 55 + 37 * ((State - 40) div 4);
              BitMap.Transparent := True;
              if FileExists (Concat (Path, BlackUpName)) Then
              begin
                BitMap.LoadFromFile (Concat (Path, BlackUpName));
                BitMap.TransparentColor := BitMap.Canvas.Pixels [BitMap.Width div 2, BitMap.Height div 2];
                Face.Canvas.Draw (411 + 37 * ((State - 40) mod 4), 55 + 37 * ((State - 40) div 4), BitMap);
              end; {if}
            end; {40..57}
    58: begin {EXE}
          if FileExists (Concat (Path, ExeUpName)) Then
          begin
            BitMap.LoadFromFile (Concat (Path, ExeUpName));
            BitMap.Transparent := True;
            BitMap.TransparentColor := BitMap.Canvas.Pixels [BitMap.Width div 2, BitMap.Height div 2];
            Face.Canvas.Draw (485, 203, BitMap);
          end; {if}
        end; {58}
  end; {case}
  State := 0;
  StopKey := False;  
  KeyTimer.Enabled := False
end;

procedure TFormMK.FaceBoxMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var L, T: Integer;
    ST: Boolean;
begin
  if MD then
  begin
    Left := Left + (X - XPos);
    Top := Top + (Y - YPos);
    Exit;
  end; {if}
  ST := False;
  case State of
    1: begin {Power}
         if (X >= 56) and (X <= 86) and (Y >= 106) and (Y <= 126) then
         begin
           if FileExists (Concat (Path, OffName)) Then
              BitMap.LoadFromFile (Concat (Path, OffName));
         end else
         begin
           if FileExists (Concat (Path, OnName)) Then
              BitMap.LoadFromFile (Concat (Path, OnName));
         end; {if}
         Face.Canvas.Draw (56, 106, BitMap);
       end; {1}
    5..39: begin {White Key}
             L := 18 + 38 * (State mod 10);
             T := 107 + 33 * (State div 10);
             BitMap.Transparent := True;
             if (X >= L) and (X <= L + 30) and (Y >= T) and (Y <= T + 18) then
             begin
               if FileExists (Concat (Path, WhiteDownName)) Then
                  BitMap.LoadFromFile (Concat (Path, WhiteDownName));
             end else
             begin
               if FileExists (Concat (Path, WhiteUpName)) Then
                  BitMap.LoadFromFile (Concat (Path, WhiteUpName));
               ST := True;
             end; {if}
             BitMap.TransparentColor := BitMap.Canvas.Pixels [BitMap.Width div 2, BitMap.Height div 2];
             Face.Canvas.Draw (18 + 38 * (State mod 10), 107 + 33 * (State div 10), BitMap);
           end; {5..39}
    40..57: begin {Black Key}
              L := 411 + 37 * ((State - 40) mod 4);
              T := 55 + 37 * ((State - 40) div 4);
              BitMap.Transparent := True;
              if (X >= L) and (X <= L + 26) and (Y >= T) and (Y <= T + 20) then
              begin
                if FileExists (Concat (Path, BlackDownName)) Then
                   BitMap.LoadFromFile (Concat (Path, BlackDownName));
              end else
              begin
                if FileExists (Concat (Path, BlackUpName)) Then
                   BitMap.LoadFromFile (Concat (Path, BlackUpName));
                ST := True;
              end; {if}
              BitMap.TransparentColor := BitMap.Canvas.Pixels [BitMap.Width div 2, BitMap.Height div 2];
              Face.Canvas.Draw (411 + 37 * ((State - 40) mod 4), 55 + 37 * ((State - 40) div 4), BitMap);
            end; {40..57}
    58: begin {EXE}
          if (X >= 485) and (X <= 548) and (Y >= 203) and (Y <= 223) then
          begin
            if FileExists (Concat (Path, ExeDownName)) Then
               BitMap.LoadFromFile (Concat (Path, ExeDownName));
          end else
          begin
            if FileExists (Concat (Path, ExeUpName)) Then
               BitMap.LoadFromFile (Concat (Path, ExeUpName));
            ST := True;
          end; {if}
          BitMap.Transparent := True;
          BitMap.TransparentColor := BitMap.Canvas.Pixels [BitMap.Width div 2, BitMap.Height div 2];
          Face.Canvas.Draw (485, 203, BitMap);
        end; {58}
  end; {case}
  if ST then
  begin
    State := 0;
    StopKey := False;
    KeyTimer.Enabled := False;
  end; {if}
end;

procedure TFormMK.FormShow(Sender: TObject);
begin
  OpenFont;
  Init;
  FaceBox.Width := Face.Width;
  FaceBox.Height := Face.Height;
  RefreshTimer.Enabled := True;
  if not BTest then
  begin
    Cls;
    SetText (0, DeCoder ('READY P0', True));
    Hlp[3] := True;
    Hlp[5] := True;
    View;
    EditCls := True;
    KeyCode := 0;
    EditTimer.Enabled := True;
  end; {if}
end;

procedure TFormMK.FormCreate(Sender: TObject);
begin
  BitMap := TBitMap.Create;
  Face := TBitMap.Create;
  MemFace := TBitMap.Create;
  Cloak := TBitMap.Create;    
  BkColor := RGB (240, 240, 240) {clWhite{};
  Randomize;
  BTest := False;
  CtrlV := False;  
  MemTotal := 5317;
  MemLoad ('AutoSave.mem');
end;

procedure TFormMK.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  BTest := False;
  BitMap.Free;
  Face.Free;
  MemFace.Free;
  Cloak.Free;
  MemSave ('AutoSave.mem');
  MemDestroy;
end;

procedure TFormMK.CursorTimerTimer(Sender: TObject);
var I, J: Integer;
begin
  if CurVis then
  begin
    for I := 0 to 4 do
      for J := 0 to 6 do
        Scr[CurPos*5+I,J] := CurMem[I,J];
  end else
  begin
    for I := 0 to 4 do
      for J := 0 to 6 do
        Scr[CurPos*5+I,J] := False;
    for I := 0 to 4 do
      for J := CurDn to CurUp do
        Scr[CurPos*5+I,J] := True;
  end; {if}
  View;
  CurVis := not CurVis;
end;

procedure TFormMK.KeyTimerTimer(Sender: TObject);
begin
  KeyTimer.Interval := KeyPs;
  InKey (State, False);
end;

procedure TFormMK.EditTimerTimer(Sender: TObject);
const SCode: array[1..30] of Byte =
        (81,87,69,82,84,89,85,73,79,80,65,83,68,70,71,72,74,75,76,9,90,88,67,86,66,78,77,32,61,123);
      SSLine: array[11..28] of string =
        ('GOSUB ',
         'FOR ',
         ' TO ',
         ' STEP ',
         'NEXT ',
         'GOTO ',
         'IF ',
         ' THEN ',
         'PRINT ',
         'DRAWC ',
         'RETURN',
         'STOP',
         'END',
         'DEFM ',
         'RUN ',
         'LIST ',
         'INPUT ',
         'LETC ');
      FSLine: array[1..30] of string =
        ('SET ',
         'MODE ',
         'VAL ',
         'MID(',
         'LEN ',
         'KEY',
         'CLEAR ',
         'VAC',
         'RND(',
         'AUTO ',
         'SIN ',
         'COS ',
         'TAN ',
         'ASN ',
         'ACS ',
         'ATN ',
         'LOG ',
         'LN ',
         'EXP ',
         'DRAW ',
         'SQR ',
         'ABS ',
         'SGN ',
         'INT ',
         'FRAC ',
         'RAN#',
         'CSR ',
         'GETC(',
         'ASCI ',
         'CHR ');
var Key: Byte;
    I: Integer;
    Rec: string;
begin
  Rec := '';
  if CtrlV then
  begin {   :}
    CtrlV := False;
    with ClipBoard do
    begin
      Open;
      if HasFormat (CF_TEXT)
        then Rec := DeCoder (AsText, True);
      Close;
    end; {with}
  end; {if}
  Key := KeyCode;
  KeyCode := 0;
  if (Key = 9) and not (SShift xor FShift) then Rec := ANSLine;
  if SShift and not FShift and ((Key <> 32) or not Hlp[0]) then
  begin {SShift}
    for I := 11 to 28 do
      if Key = SCode[I] then Rec := SSLine[I];
  end; {if}
  if not SShift and FShift and (not Hlp[0] or (Key = 9)) then
  begin {FShift}
    for I := 1 to 30 do
      if Key = SCode[I] then Rec := FSLine[I];
  end; {if}
  if Rec <> '' then
  begin { :}
    if EditCls then
    begin
      EditCls := False;
      Cls;
    end; {if}
    for I := 1 to Length (Rec) do
    begin
      if EditPos <= MaxLen then
      begin
        if EditPos <= Length (EditLine)
          then EditLine[EditPos] := Rec[I]
          else EditLine := Concat (EditLine, Rec[I]);
        Inc (EditPos);
      end; {if}
    end; {for}
    ShowEdit;
    Exit;
  end; {if}
  if not Hlp[0] and (Key = 45) and (EditPos > 1) and (Ord (EditLine[EditPos-1]) = 123) then
  begin
    EditLine[EditPos-1] := #125;
    ShowEdit;
    Exit;
  end; {if}
  if Key > 0 then
  begin { :}
    if (Key >= 48) and (Key <= 57) and SShift and FShift then
    begin {MODE+}
      case Key of
        48: {RUN};
        49: {WRT};
        50: Hlp[8] := True;
        51: Hlp[8] := False;
        52: begin {MODE+4}
              Hlp[5] := True;
              Hlp[6] := False;
              Hlp[7] := False;
            end; {58}
        53: begin {MODE+5}
              Hlp[5] := False;
              Hlp[6] := True;
              Hlp[7] := False;
            end; {59}
        54: begin {MODE+6}
              Hlp[5] := False;
              Hlp[6] := False;
              Hlp[7] := True;
            end; {60}
      end; {case}
      View;
      Exit;
    end; {if}
    if EditCls then
    begin
      if Key in [4,5,6,8] then Exit;
      EditCls := False;
      Cls;
    end; {if}
    case Key of
      4: EXE;
      5: if EditPos > 1 then Dec (EditPos);
      6: if EditPos <= Length (EditLine) then Inc (EditPos);
      7: Cls;
      8: if SShift and not FShift then
         begin
           if (Length (EditLine) < MaxLen) and (EditPos <= Length (EditLine))
             then EditLine := Concat (Copy (EditLine, 1, EditPos - 1), ' ', Copy (EditLine, EditPos, Length (EditLine) - EditPos + 1));
         end else
         begin
           EditLine := Concat (Copy (EditLine, 1, EditPos - 1), Copy (EditLine, EditPos + 1, Length (EditLine) - EditPos));
         end; {if}
      10: SetOne;
      else
      begin
        if EditPos <= MaxLen then
        begin
          if EditPos <= Length (EditLine)
            then EditLine[EditPos] := Chr (Key)
            else EditLine := Concat (EditLine, Chr (Key));
          Inc (EditPos);
        end; {if}
      end; {else}
    end; {case}
    if not EditCls then ShowEdit;
  end; {if}
end;

procedure TFormMK.FormKeyPress(Sender: TObject; var Key: Char);
begin
  if Key = #22 then
  begin {Ctrl+V}
    CtrlV := True;
    Exit;
  end; {if}
  if (Key = #3) or (Key = #24) then
  begin {Ctrl+C, Ctrl+X}
    with ClipBoard do
    begin
      Open;
      AsText := DeCoder (EditLine, False);
      Close;
    end; {with}
    if Key = #24 then
    begin
      SShift := False;
      FShift := False;
      KeyCode := 7;
    end; {if}
    Exit;
  end; {if}

  SShift := False;
  FShift := False;
  case Key of
    #13: KeyCode := 4;
    #27: KeyCode := 7;
    else KeyCode := Ord (DeCoder (Key, True)[1]);
  end; {case}
  if KeyCode > 191 then KeyCode := 0;
end;

procedure TFormMK.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  SShift := False;
  FShift := False;
  case Key of
    vk_Home: KeyCode := 9;
    vk_Left: KeyCode := 5;
    vk_Right: KeyCode := 6;
    vk_Delete: KeyCode := 8;
    vk_Insert: begin
                 KeyCode := 8;
                 SShift := True;
               end; {vk_Insert}
  end; {case}
end;

end.
